> ## Documentation Index
> Fetch the complete documentation index at: https://docs.immutable.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Mint NFTs

> Create a mint request to mint a set of NFTs for a given collection



## OpenAPI

````yaml https://imx-openapiv3-mr-sandbox.s3.us-east-2.amazonaws.com/openapi.json post /v1/chains/{chain_name}/collections/{contract_address}/nfts/mint-requests
openapi: 3.0.3
info:
  title: Immutable zkEVM API
  version: 1.0.0
  description: Immutable Multi Rollup API
  contact:
    name: Immutable API Support
    email: support@immutable.com
    url: https://support.immutable.com
servers:
  - url: https://api.sandbox.immutable.com
security: []
tags:
  - name: activities
    description: Activities Endpoints
    x-displayName: activities
  - name: chains
    description: Chains Endpoints
    x-displayName: chains
  - name: collections
    description: Collections Endpoints
    x-displayName: collections
  - name: nfts
    description: NFTs Endpoints
    x-displayName: nfts
  - name: nft owners
    description: NFT Owner Endpoints
    x-displayName: nft owners
  - name: metadata
    description: NFT Metadata Endpoints
    x-displayName: metadata
  - name: tokens
    description: ERC20 Token Endpoints
    x-displayName: tokens
  - name: demopage
    description: Temporary HTML endpoint for demo purposes
    x-displayName: demopage
  - name: verification
    x-displayName: verification
  - name: operatorallowlist
    x-displayName: operatorallowlist
  - name: crafting
    x-displayName: crafting
  - name: listings
    description: Listings Endpoints
    x-displayName: listings
  - name: orders
    x-displayName: orders
  - name: passport
    description: Passport operations
    x-displayName: passport
  - name: gamefi
    description: team gamefi
    x-displayName: gamefi
  - name: health
    x-displayName: health
  - name: passport profile
    description: Passport Profile endpoints
    x-displayName: passport profile
  - name: feed-items
    x-displayName: feed-items
  - name: assets
    x-displayName: assets
  - name: guardian
    description: Guardian endpoints
    x-displayName: guardian
  - name: pricing
    description: Pricing Endpoints
    x-displayName: pricing
  - name: metadata-search
    x-displayName: metadata-search
paths:
  /v1/chains/{chain_name}/collections/{contract_address}/nfts/mint-requests:
    post:
      tags:
        - nfts
      summary: Mint NFTs
      description: Create a mint request to mint a set of NFTs for a given collection
      operationId: CreateMintRequest
      parameters:
        - name: contract_address
          in: path
          description: The address of contract
          required: true
          schema:
            type: string
          example: '0x8a90cab2b38dba80c64b7734e58ee1db38b8992e'
        - name: chain_name
          description: The name of chain
          in: path
          required: true
          schema:
            $ref: '#/components/schemas/ChainName'
      requestBody:
        description: Create Mint Request Body
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/CreateMintRequestRequest'
      responses:
        '202':
          description: Accepted
          headers:
            imx-mint-requests-limit:
              $ref: '#/components/headers/MintRequestsLimit'
            imx-mint-requests-limit-reset:
              $ref: '#/components/headers/MintRequestsLimitReset'
            imx-remaining-mint-requests:
              $ref: '#/components/headers/MintRequestsLimitRemaining'
            imx-mint-requests-retry-after:
              $ref: '#/components/headers/MintRequestsRetryAfter'
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CreateMintRequestResult'
        '400':
          $ref: '#/components/responses/BadRequest'
        '401':
          $ref: '#/components/responses/UnauthorisedRequest'
        '403':
          $ref: '#/components/responses/ForbiddenRequest'
        '404':
          $ref: '#/components/responses/NotFound'
        '409':
          $ref: '#/components/responses/Conflict'
        '429':
          $ref: '#/components/responses/TooManyMintRequests'
        '500':
          $ref: '#/components/responses/InternalServerError'
      security:
        - ImmutableApiKey:
            - write:mint-request
components:
  schemas:
    ChainName:
      type: string
      description: The name of chain
      example: imtbl-zkevm-testnet
    CreateMintRequestRequest:
      type: object
      properties:
        assets:
          type: array
          maxItems: 100
          minItems: 1
          description: List of nft to be minted
          items:
            $ref: '#/components/schemas/MintAsset'
      required:
        - assets
    CreateMintRequestResult:
      type: object
      properties:
        imx_mint_requests_limit:
          type: string
        imx_mint_requests_limit_reset:
          type: string
        imx_remaining_mint_requests:
          type: string
        imx_mint_requests_retry_after:
          type: string
      required:
        - imx_mint_requests_limit
        - imx_mint_requests_limit_reset
        - imx_remaining_mint_requests
        - imx_mint_requests_retry_after
    MintAsset:
      type: object
      properties:
        reference_id:
          type: string
          description: The id of this asset in the system that originates the mint request
          example: 67f7d464-b8f0-4f6a-9a3b-8d3cb4a21af0
        owner_address:
          type: string
          description: The address of the receiver
          example: '0xc344c05eef8876e517072f879dae8905aa2b956b'
        token_id:
          type: string
          description: >-
            An optional `uint256` token id as string. Required for ERC1155
            collections.
          example: '1'
          nullable: true
        amount:
          type: string
          description: >-
            Optional mount of tokens to mint. Required for ERC1155 collections.
            ERC712 collections can omit this field or set it to 1
          example: '1'
          nullable: true
          minLength: 1
        metadata:
          $ref: '#/components/schemas/NFTMetadataRequest'
      required:
        - reference_id
        - owner_address
    APIError400:
      allOf:
        - $ref: '#/components/schemas/BasicAPIError'
        - type: object
          properties:
            code:
              type: string
              description: Error Code
              enum:
                - VALIDATION_ERROR
              example: VALIDATION_ERROR
            details:
              type: object
              nullable: true
              description: Additional details to help resolve the error
          required:
            - code
            - details
    APIError401:
      allOf:
        - $ref: '#/components/schemas/BasicAPIError'
        - type: object
          properties:
            code:
              type: string
              description: Error Code
              enum:
                - UNAUTHORISED_REQUEST
              example: UNAUTHORISED_REQUEST
            details:
              type: object
              nullable: true
              description: Additional details to help resolve the error
          required:
            - code
            - details
    APIError403:
      allOf:
        - $ref: '#/components/schemas/BasicAPIError'
        - type: object
          properties:
            code:
              type: string
              description: Error Code
              enum:
                - AUTHENTICATION_ERROR
              example: AUTHENTICATION_ERROR
            details:
              type: object
              nullable: true
              description: Additional details to help resolve the error
          required:
            - code
            - details
    APIError404:
      allOf:
        - $ref: '#/components/schemas/BasicAPIError'
        - type: object
          properties:
            code:
              type: string
              description: Error Code
              enum:
                - RESOURCE_NOT_FOUND
              example: RESOURCE_NOT_FOUND
            details:
              type: object
              nullable: true
              description: Additional details to help resolve the error
          required:
            - code
            - details
    APIError409:
      allOf:
        - $ref: '#/components/schemas/BasicAPIError'
        - type: object
          properties:
            code:
              type: string
              description: Error Code
              enum:
                - CONFLICT_ERROR
              example: CONFLICT_ERROR
            details:
              type: object
              nullable: true
              description: Additional details to help resolve the error
              additionalProperties: true
          required:
            - code
            - details
    APIError429:
      allOf:
        - $ref: '#/components/schemas/BasicAPIError'
        - type: object
          properties:
            code:
              type: string
              description: Error Code
              enum:
                - TOO_MANY_REQUESTS_ERROR
              example: TOO_MANY_REQUESTS_ERROR
            details:
              type: object
              nullable: true
              description: Additional details to help resolve the error
          required:
            - code
            - details
    APIError500:
      allOf:
        - $ref: '#/components/schemas/BasicAPIError'
        - type: object
          properties:
            code:
              type: string
              description: Error Code
              enum:
                - INTERNAL_SERVER_ERROR
              example: INTERNAL_SERVER_ERROR
            details:
              type: object
              nullable: true
              description: Additional details to help resolve the error
          required:
            - code
            - details
    NFTMetadataRequest:
      type: object
      description: The NFT metadata. Total size of this object should not exceed 16 KiB
      properties:
        name:
          type: string
          nullable: true
          example: Sword
          description: The name of the NFT
        description:
          type: string
          nullable: true
          example: '2022-08-16T17:43:26.991388Z'
          description: The description of the NFT
        image:
          type: string
          nullable: true
          description: The image url of the NFT
          example: https://some-url
        external_url:
          type: string
          nullable: true
          description: The external link of the NFT
          example: https://some-url
        animation_url:
          type: string
          nullable: true
          description: The animation url of the NFT
          example: https://some-url
        youtube_url:
          type: string
          nullable: true
          description: The youtube link of the NFT
          example: https://some-url
        attributes:
          type: array
          description: List of Metadata attributes
          nullable: true
          items:
            $ref: '#/components/schemas/NFTMetadataAttribute'
    BasicAPIError:
      type: object
      properties:
        message:
          type: string
          description: Error Message
          example: all fields must be provided
        link:
          type: string
          description: Link to IMX documentation that can help resolve this error
          example: https://docs.x.immutable.com/reference/#/
        trace_id:
          type: string
          description: Trace ID of the initial request
          example: e47634b79a5cd6894ddc9639ec4aad26
      required:
        - message
        - link
        - trace_id
    NFTMetadataAttribute:
      type: object
      properties:
        display_type:
          description: Display type for this attribute
          type: string
          nullable: true
          enum:
            - number
            - boost_percentage
            - boost_number
            - date
          example: number
        trait_type:
          description: The metadata trait type
          type: string
          example: Aqua Power
        value:
          oneOf:
            - type: string
            - type: number
            - type: boolean
          description: The metadata trait value
          example: Happy
      required:
        - trait_type
        - value
  headers:
    MintRequestsLimit:
      description: The mint requests limit available to the project for each time window.
      schema:
        type: string
    MintRequestsLimitReset:
      description: The expiry date of the current time window.
      schema:
        type: string
    MintRequestsLimitRemaining:
      description: The number of mint requests remaining in the current window.
      schema:
        type: string
    MintRequestsRetryAfter:
      description: The number of seconds until the next refresh request can be made.
      schema:
        type: string
  responses:
    BadRequest:
      description: Bad Request (400)
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/APIError400'
    UnauthorisedRequest:
      description: Unauthorised Request (401)
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/APIError401'
    ForbiddenRequest:
      description: Forbidden Request (403)
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/APIError403'
    NotFound:
      description: The specified resource was not found (404)
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/APIError404'
    Conflict:
      description: Conflict (409)
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/APIError409'
    TooManyMintRequests:
      description: Too Many mint requests (429)
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/APIError429'
      headers:
        imx-mint-requests-limit:
          $ref: '#/components/headers/MintRequestsLimit'
        imx-mint-requests-limit-reset:
          $ref: '#/components/headers/MintRequestsLimitReset'
        imx-remaining-mint-requests:
          $ref: '#/components/headers/MintRequestsLimitRemaining'
        imx-mint-requests-retry-after:
          $ref: '#/components/headers/MintRequestsRetryAfter'
        Retry-After:
          $ref: '#/components/headers/MintRequestsRetryAfter'
    InternalServerError:
      description: Internal Server Error (500)
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/APIError500'
  securitySchemes:
    ImmutableApiKey:
      x-go-name: ImmutableApiKey
      type: apiKey
      in: header
      name: x-immutable-api-key

````